; CMFILTER.ASM--
; Copyright (C) 2016 Doszip Developers -- see LICENSE.TXT

include doszip.inc
include stdio.inc
include stdlib.inc
include string.inc
include time.inc

ID_INCLUDE  equ 1*16
ID_EXCLUDE  equ 2*16
ID_MIN_DATE equ 3*16
ID_MAX_DATE equ 4*16
ID_MIN_SIZE equ 5*16
ID_MAX_SIZE equ 6*16
ID_RDONLY   equ 7*16
ID_HIDDEN   equ 8*16
ID_SYSTEM   equ 9*16
ID_VOLID    equ 10*16
ID_SUBDIR   equ 11*16
ID_ARCH	    equ 12*16
ID_OK	    equ 13*16
ID_CLEAR    equ 14*16
ID_CANCEL   equ 15*16

    .data

externdef   format_lu:byte
externdef   cp_stdmask:sbyte
externdef   IDD_OperationFilters:dword
externdef   IDD_DZFindFile:dword
cp_filter   db "Filter",0
filter_keys dd KEY_F3, cmfilter_load
	    dd KEY_F4, cmfilter_date
	    dd 0

    .code

cmfilter_load proc uses esi edi ebx
  local filt[FILT_MAXSTRING]:byte
    mov ebx,tdialog
    mov eax,IDD_DZFindFile
    mov dl,[eax].S_ROBJ.rs_count
    mov edi,0D0Dh
    .if [ebx].S_DOBJ.dl_count != dl
	mov edi,1
    .endif
    tools_idd(128, &filt, &cp_filter)
    mov edx,eax
    msloop()
    .if edx && edx != MOUSECMD
	mov eax,edi
	.if [ebx].S_DOBJ.dl_index != al
	    mov [ebx].S_DOBJ.dl_index,ah
	.endif
	movzx ecx,[ebx].S_DOBJ.dl_index
	shl ecx,4
	add ecx,[ebx].S_DOBJ.dl_object
	strcpy([ecx].S_TOBJ.to_data, &filt)
	dlinit(ebx)
    .endif
    mov eax,_C_NORMAL
    ret
cmfilter_load endp

cmfilter_date proc private uses edi ebx
    mov edi,tdialog
    mov al,[edi].S_DOBJ.dl_index
    .if al != 2 && al != 3
	mov [edi].S_DOBJ.dl_index,2
    .endif
    .if cmcalendar()
	mov ebx,eax
	movzx eax,[edi].S_DOBJ.dl_index
	inc eax
	shl eax,4
	add eax,edi
	sprintf([eax].S_TOBJ.to_data, &cp_datefrm, edx, ebx, ecx)
	dlinit(edi)
    .endif
    mov eax,_C_NORMAL
    ret
cmfilter_date endp

TDateToString proc private string:ptr sbyte, tptr:time_t

  local SystemTime:SYSTEMTIME

    TimeToSystemTime(tptr, &SystemTime)
    SystemDateToStringA(string, &SystemTime)
    ret

TDateToString endp

atodate proc private string:ptr sbyte

  local SystemTime:SYSTEMTIME

    StringToSystemDateA(string, &SystemTime)

    movzx eax,SystemTime.wYear
    movzx edx,SystemTime.wMonth
    movzx ecx,SystemTime.wDay
    .if eax <= 1900	; year yy | yyyy
	.if eax < 80
	    add eax,100
	.endif
	add eax,1900
    .endif
    sub eax,DT_BASEYEAR
    shl eax,9		; year
    shl edx,5		; month
    or	eax,edx
    or	eax,ecx		; yyyyyyymmmmddddd
    shl eax,16		; <date>:<time>
    ret

atodate endp

filter_edit proc uses esi edi ebx filt:ptr, glcmd:ptr

  local FileTime:FILETIME

    .if rsopen(IDD_OperationFilters)

	mov edi,eax
	mov esi,filt
	mov filter,esi
	push thelp
	mov thelp,event_help

	lea eax,[esi].S_FILT.of_include
	mov [edi].S_TOBJ.to_data[ID_INCLUDE],eax
	add eax,128
	mov [edi].S_TOBJ.to_data[ID_EXCLUDE],eax
	mov [edi].S_TOBJ.to_count[ID_INCLUDE],8
	mov [edi].S_TOBJ.to_count[ID_EXCLUDE],8
	mov eax,glcmd
	mov [edi].S_TOBJ.to_data[ID_OK],eax
	mov [edi].S_TOBJ.to_proc[ID_CLEAR],event_clear
	.if [esi].S_FILT.of_min_date
	    TDateToString([edi].S_TOBJ.to_data[ID_MIN_DATE], [esi].S_FILT.of_min_date)
	.endif
	.if [esi].S_FILT.of_max_date
	    TDateToString([edi].S_TOBJ.to_data[ID_MAX_DATE], [esi].S_FILT.of_max_date)
	.endif
	.if [esi].S_FILT.of_min_size
	    sprintf([edi].S_TOBJ.to_data[ID_MIN_SIZE], &format_lu,[esi].S_FILT.of_min_size)
	.endif
	.if [esi].S_FILT.of_max_size
	    sprintf([edi].S_TOBJ.to_data[ID_MAX_SIZE], &format_lu,[esi].S_FILT.of_max_size)
	.endif
	lea ebx,[edi+ID_RDONLY]
	mov eax,[esi].S_FILT.of_flag

	tosetbitflag(ebx, 6, _O_FLAGB, eax)
	dlinit(edi)
	rsevent(IDD_OperationFilters, edi)
	dlclose(edi)

	pop eax
	mov thelp,eax
	.if edx
	    togetbitflag(&[edi][ID_RDONLY], 6, _O_FLAGB)
	    or	eax,0FFC0h
	    mov [esi].S_FILT.of_flag,eax
	    strtolx([edi].S_TOBJ.to_data[ID_MAX_SIZE])
	    mov [esi].S_FILT.of_max_size,eax
	    strtolx([edi].S_TOBJ.to_data[ID_MIN_SIZE])
	    mov [esi].S_FILT.of_min_size,eax
	    atodate([edi].S_TOBJ.to_data[ID_MAX_DATE])
	    mov [esi].S_FILT.of_max_date,eax
	    atodate([edi].S_TOBJ.to_data[ID_MIN_DATE])
	    mov [esi].S_FILT.of_min_date,eax
	    mov eax,_C_NORMAL
	.else
	    xor eax,eax
	    mov filter,eax
	.endif
    .else
	xor eax,eax
	mov filter,eax
    .endif
    ret

event_clear:
    mov ecx,esi
    mov esi,tdialog
    xor eax,eax
    mov edx,[esi].S_TOBJ.to_data[ID_MIN_DATE]
    mov [edx],al
    mov edx,[esi].S_TOBJ.to_data[ID_MAX_DATE]
    mov [edx],al
    mov edx,[esi].S_TOBJ.to_data[ID_MIN_SIZE]
    mov [edx],al
    mov edx,[esi].S_TOBJ.to_data[ID_MAX_SIZE]
    mov [edx],al
    mov esi,ecx
    memset(filter, 0, sizeof(S_FILT))
    mov edx,filter
    strcpy(&[edx].S_FILT.of_include, &cp_stdmask)
    mov [edx].S_FILT.of_flag,-1
    mov eax,tdialog
    add eax,ID_RDONLY
    tosetbitflag(eax, 6, _O_FLAGB, 0FFFFFFFFh)
    mov eax,_C_REOPEN
    retn

event_help:
    view_readme(HELPID_12)
    retn
filter_edit endp

cmfilter proc
    filter_edit(&opfilter, &filter_keys)
    ret
cmfilter endp

    END
